# Taller de TUPAC

[Filminas de la charla](https://docs.google.com/presentation/d/17K76Zx4Rin4IDFLLV7D73egm_Eh0gkJJfBsoMjVAWh8/edit?usp=sharing)

Video charla 1er cuatrimestre 2024:

[![thumbnail](https://img.youtube.com/vi/EbSzqjLSIZE/0.jpg)](https://www.youtube.com/watch?v=EbSzqjLSIZE)

## Hola mundo

### `hola_openmp.c`

Compilar con `gcc -fopenmp`.

Usar la variable de entorno `OMP_NUM_THREADS` para variar el número de hilos.

### `hola_mpi.c`

Compilar con `mpicc`.

Probar ejecutando sin entorno MPI, con `mpirun -np x` y con `sbatch slurm-hola`.

## Pi

- 00: Versión secuencial, sin inicializar semilla de `random()`.
- 01: Secuencial con `srand(time(NULL))`.
- 02: Versión OpenMP, importante que se cambia `random()` por `rand_r()` para
    poder tener una semilla independiente para cada proceso. Notar que el tiempo
    de user es el real sumando los procesadores.
- 03: Version MPI, corre con `sbatch slurm-03_pi_mpi`.
